/*
 * Simple fragment shader for calculating output fragment color.
 */

#version 130          // delete this line if using GLSL 1.2
precision mediump float;  // delete this line if using GLSL 1.2

// sampler holding texture data
uniform sampler2D colorTexture;
//uniform vec4 frag_color

// fragment-shader input variables
in vec2 fragTexCoord;

// fragment-shader output variable (-> stored in the frame-buffer, i.e. "the pixel you see")
out vec4 hudColor;


void main()
{       
    //get texel color
    vec4 texel = texture(colorTexture, fragTexCoord);
    
    // write color to output
    if (texel.x == 0 && texel.y == 0 && texel.z ==0) {
		discard;
	}
    hudColor = texel;

}