/*
 * Simple vertex shader calculating world position, 
 * passing texture coordinates and more.
 */

#version 130              // delete this line if using GLSL 1.2
precision mediump float;  // delete this line if using GLSL 1.2

// uniform shader-parameters
uniform mat4 view;

// vertex-shader input variables
in vec4 vertex;
in vec2 texCoord;

// vertex-shader output variables (passed to fragment-shader)
out vec2 fragTexCoord;


void main()
{
    // transform vertex down the pipeline
    gl_Position = view * vertex;
    
    // pass texture coordinate
    fragTexCoord = texCoord;
}