
#version 130              // delete this line if using GLSL 1.2
precision mediump float;  // delete this line if using GLSL 1.2



// uniform shader-parameters
uniform mat4 PV; //cam space
uniform mat4 model;
uniform mat4 T; //light space
uniform vec4 clipPlane;

// vertex-shader input variables
in vec3 normal;
in vec4 vertex;
in vec2 texCoord;

// vertex-shader output variables (passed to fragment-shader)
out vec2 frag_texCoord;
out vec3 world_normal;
out vec4 world_position;
out vec4 SM_texCoord;
out float gl_ClipDistance[1];


void main()
{
	// transform normal into world space
	vec4 normal4 = vec4(normal, 0.0f);
    world_normal = (model * normal4).xyz;
    
    // transform vertex to world-space
    world_position = model * vertex;
    
    gl_ClipDistance[0] = dot(world_position, clipPlane);
    
    // just pass color to fragment-shader
    frag_texCoord = texCoord;
    
    SM_texCoord = T * model * vertex;

    // transform vertex down the pipeline
    gl_Position = PV * model * vertex;
}
