#version 130 
precision mediump float;

out vec4 waterTex0; //lightpos
out vec4 waterTex1; //moving texcoords
out vec4 waterTex2; //moving texcoords
out vec4 waterTex3; //for projection
out vec4 waterTex4; //viewts

uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;

// vertex-shader input variables
in vec4 vertex;
in vec4 texCoordReflection;

uniform vec4 viewpos, lightpos;
uniform float time, time2;

//unit 0 = water_reflection
//unit 1 = water_refraction
//unit 2 = water_normalmap
//unit 3 = water_dudvmap
//unit 4 = water_depthmap

void main(void)
{
    
    // transform vertex to world-space
    vec4 world_position = model * vertex;

	//tangentspace
	vec4 mpos, temp;
	vec4 tangent = vec4(1.0, 0.0, 0.0, 0.0);
	vec4 norm = vec4(0.0, 1.0, 0.0, 0.0);
	vec4 binormal = vec4(0.0, 0.0, 1.0, 0.0);

	mat4 mvp = perspective * view * model;

	//viewts
	temp = viewpos - world_position;
	waterTex4.x = dot(temp, tangent);
	waterTex4.y = dot(temp, binormal);
	waterTex4.z = dot(temp, norm);
	waterTex4.w = 1.0;
	
	//lightpos
	temp = lightpos - world_position;
	waterTex0.x = dot(temp, tangent);
	waterTex0.y = dot(temp, binormal);
	waterTex0.z = dot(temp, norm);
	waterTex0.w = 1.0;

	mpos = mvp * vertex;

	vec4 t1 = vec4(0.0, -time, 0.0,0.0);
	vec4 t2 = vec4(0.0, -time2, 0.0,0.0);
	
	//moving texcoords
	waterTex1 = texCoordReflection * 10.0f + t1;
	waterTex2 = texCoordReflection * 10.0f + t2;

	//for projection
	waterTex3 = mpos;

	// transform vertex down the pipeline
    gl_Position = mpos;
}